/* media.c generated by valac 0.15.1, the Vala compiler
 * generated from media.vala, do not modify */

/* vim: set tabstop=8 softtabstop=2 shiftwidth=2 expandtab: */
/*
 *    Copyright (C) 2011 Fabian Deutsch
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gst/rtsp-server/rtsp-media-factory.h>
#include <gst/rtsp-server/rtsp-client.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <gst/rtsp-server/rtsp-server.h>
#include <gst/rtsp-server/rtsp-media-mapping.h>
#include <float.h>
#include <math.h>


#define MEDIA_TYPE_RTSP_CLIENT (media_rtsp_client_get_type ())
#define MEDIA_RTSP_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MEDIA_TYPE_RTSP_CLIENT, MediaRTSPClient))
#define MEDIA_RTSP_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MEDIA_TYPE_RTSP_CLIENT, MediaRTSPClientClass))
#define MEDIA_IS_RTSP_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MEDIA_TYPE_RTSP_CLIENT))
#define MEDIA_IS_RTSP_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MEDIA_TYPE_RTSP_CLIENT))
#define MEDIA_RTSP_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MEDIA_TYPE_RTSP_CLIENT, MediaRTSPClientClass))

typedef struct _MediaRTSPClient MediaRTSPClient;
typedef struct _MediaRTSPClientClass MediaRTSPClientClass;
typedef struct _MediaRTSPClientPrivate MediaRTSPClientPrivate;
#define _gst_object_unref0(var) ((var == NULL) ? NULL : (var = (gst_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gst_structure_free0(var) ((var == NULL) ? NULL : (var = (gst_structure_free (var), NULL)))

#define MEDIA_TYPE_LOCAL_RTSP_SERVER (media_local_rtsp_server_get_type ())
#define MEDIA_LOCAL_RTSP_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MEDIA_TYPE_LOCAL_RTSP_SERVER, MediaLocalRTSPServer))
#define MEDIA_LOCAL_RTSP_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MEDIA_TYPE_LOCAL_RTSP_SERVER, MediaLocalRTSPServerClass))
#define MEDIA_IS_LOCAL_RTSP_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MEDIA_TYPE_LOCAL_RTSP_SERVER))
#define MEDIA_IS_LOCAL_RTSP_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MEDIA_TYPE_LOCAL_RTSP_SERVER))
#define MEDIA_LOCAL_RTSP_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MEDIA_TYPE_LOCAL_RTSP_SERVER, MediaLocalRTSPServerClass))

typedef struct _MediaLocalRTSPServer MediaLocalRTSPServer;
typedef struct _MediaLocalRTSPServerClass MediaLocalRTSPServerClass;
typedef struct _MediaLocalRTSPServerPrivate MediaLocalRTSPServerPrivate;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MediaRTSPClient {
	GObject parent_instance;
	MediaRTSPClientPrivate * priv;
};

struct _MediaRTSPClientClass {
	GObjectClass parent_class;
};

struct _MediaRTSPClientPrivate {
	GstElement* playbin;
	GstElement* video_sink;
	GstElement* audio_sink;
	gchar* _uri;
	gboolean _mute;
};

struct _MediaLocalRTSPServer {
	GObject parent_instance;
	MediaLocalRTSPServerPrivate * priv;
};

struct _MediaLocalRTSPServerClass {
	GObjectClass parent_class;
};

struct _MediaLocalRTSPServerPrivate {
	GMainLoop* loop;
	GstRTSPServer* server;
	GstRTSPMediaMapping* mapping;
	gdouble base_width;
	gdouble base_height;
	gdouble base_quality_min;
	gdouble base_quality_max;
	gdouble base_fps_min;
	gdouble base_fps_max;
	gboolean _use_ipv6;
	gchar* _port;
	gchar* _mountpoint;
	gchar* _address;
	gchar* _user;
	gchar* _password;
	gchar* _video_device;
	gdouble _video_scale_factor;
	gdouble _video_quality_factor;
	gdouble _video_fps_factor;
};


static gpointer media_rtsp_client_parent_class = NULL;
static gpointer media_local_rtsp_server_parent_class = NULL;

void gst_rtsp_media_factory_set_auth (GstRTSPMediaFactory* factory, GstRTSPAuth* auth);
void media_init (gchar*** args, int* args_length1);
GType media_rtsp_client_get_type (void) G_GNUC_CONST;
#define MEDIA_RTSP_CLIENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MEDIA_TYPE_RTSP_CLIENT, MediaRTSPClientPrivate))
enum  {
	MEDIA_RTSP_CLIENT_DUMMY_PROPERTY,
	MEDIA_RTSP_CLIENT_URI,
	MEDIA_RTSP_CLIENT_MUTE
};
void media_rtsp_client_stop (MediaRTSPClient* self);
MediaRTSPClient* media_rtsp_client_new (GstElement* vsink);
MediaRTSPClient* media_rtsp_client_construct (GType object_type, GstElement* vsink);
static void media_rtsp_client_build_playbin (MediaRTSPClient* self);
MediaRTSPClient* media_rtsp_client_new_playing (GstElement* vsink, const gchar* uri);
MediaRTSPClient* media_rtsp_client_construct_playing (GType object_type, GstElement* vsink, const gchar* uri);
void media_rtsp_client_set_uri (MediaRTSPClient* self, const gchar* value);
void media_rtsp_client_start (MediaRTSPClient* self);
static inline void _dynamic_set_stream_properties0 (GstElement* obj, GstStructure* value);
static inline void _dynamic_set_video_sink1 (GstElement* obj, GstElement* value);
static inline void _dynamic_set_audio_sink2 (GstElement* obj, GstObject* value);
static void __lambda2_ (MediaRTSPClient* self, GstElement* e);
static inline GstObject* _dynamic_get_source3 (GstObject* obj);
static inline void _dynamic_set_latency4 (GstObject* obj, gint value);
static inline void _dynamic_set_udp_buffer_size5 (GstObject* obj, gint value);
static void ___lambda2__dynamic_source_setup0_ (GstElement* _sender, gpointer self);
void _dynamic_source_setup1_connect (gpointer obj, const char * signal_name, GCallback handler, gpointer data);
const gchar* media_rtsp_client_get_uri (MediaRTSPClient* self);
static inline void _dynamic_set_uri6 (GstElement* obj, const gchar* value);
gboolean media_rtsp_client_get_mute (MediaRTSPClient* self);
void media_rtsp_client_set_mute (MediaRTSPClient* self, gboolean value);
static void media_rtsp_client_finalize (GObject* obj);
static void _vala_media_rtsp_client_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_media_rtsp_client_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType media_local_rtsp_server_get_type (void) G_GNUC_CONST;
#define MEDIA_LOCAL_RTSP_SERVER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MEDIA_TYPE_LOCAL_RTSP_SERVER, MediaLocalRTSPServerPrivate))
enum  {
	MEDIA_LOCAL_RTSP_SERVER_DUMMY_PROPERTY,
	MEDIA_LOCAL_RTSP_SERVER_USE_IPV6,
	MEDIA_LOCAL_RTSP_SERVER_PORT,
	MEDIA_LOCAL_RTSP_SERVER_MOUNTPOINT,
	MEDIA_LOCAL_RTSP_SERVER_ADDRESS,
	MEDIA_LOCAL_RTSP_SERVER_USER,
	MEDIA_LOCAL_RTSP_SERVER_PASSWORD,
	MEDIA_LOCAL_RTSP_SERVER_VIDEO_DEVICE,
	MEDIA_LOCAL_RTSP_SERVER_VIDEO_SCALE_FACTOR,
	MEDIA_LOCAL_RTSP_SERVER_VIDEO_WIDTH,
	MEDIA_LOCAL_RTSP_SERVER_VIDEO_HEIGHT,
	MEDIA_LOCAL_RTSP_SERVER_VIDEO_SIZE,
	MEDIA_LOCAL_RTSP_SERVER_VIDEO_QUALITY_FACTOR,
	MEDIA_LOCAL_RTSP_SERVER_VIDEO_QUALITY,
	MEDIA_LOCAL_RTSP_SERVER_VIDEO_FPS_FACTOR,
	MEDIA_LOCAL_RTSP_SERVER_VIDEO_FPS
};
MediaLocalRTSPServer* media_local_rtsp_server_new (void);
MediaLocalRTSPServer* media_local_rtsp_server_construct (GType object_type);
void media_local_rtsp_server_attach (MediaLocalRTSPServer* self, GMainLoop* l);
gboolean media_local_rtsp_server_get_use_ipv6 (MediaLocalRTSPServer* self);
const gchar* media_local_rtsp_server_get_port (MediaLocalRTSPServer* self);
const gchar* media_local_rtsp_server_get_mountpoint (MediaLocalRTSPServer* self);
static void media_local_rtsp_server_set_address (MediaLocalRTSPServer* self, const gchar* value);
void media_local_rtsp_server_add_mapping (MediaLocalRTSPServer* self, const gchar* mountpoint, const gchar* launchline);
static gchar* media_local_rtsp_server_build_default_launchline (MediaLocalRTSPServer* self);
const gchar* media_local_rtsp_server_get_password (MediaLocalRTSPServer* self);
const gchar* media_local_rtsp_server_get_user (MediaLocalRTSPServer* self);
const gchar* media_local_rtsp_server_get_video_device (MediaLocalRTSPServer* self);
gdouble media_local_rtsp_server_get_video_width (MediaLocalRTSPServer* self);
gdouble media_local_rtsp_server_get_video_height (MediaLocalRTSPServer* self);
gdouble media_local_rtsp_server_get_video_fps (MediaLocalRTSPServer* self);
gdouble media_local_rtsp_server_get_video_quality (MediaLocalRTSPServer* self);
void media_local_rtsp_server_quit (MediaLocalRTSPServer* self);
void media_local_rtsp_server_set_use_ipv6 (MediaLocalRTSPServer* self, gboolean value);
void media_local_rtsp_server_set_port (MediaLocalRTSPServer* self, const gchar* value);
void media_local_rtsp_server_set_mountpoint (MediaLocalRTSPServer* self, const gchar* value);
const gchar* media_local_rtsp_server_get_address (MediaLocalRTSPServer* self);
static void media_local_rtsp_server_set_user (MediaLocalRTSPServer* self, const gchar* value);
void media_local_rtsp_server_set_password (MediaLocalRTSPServer* self, const gchar* value);
void media_local_rtsp_server_set_video_device (MediaLocalRTSPServer* self, const gchar* value);
gdouble media_local_rtsp_server_get_video_scale_factor (MediaLocalRTSPServer* self);
void media_local_rtsp_server_set_video_scale_factor (MediaLocalRTSPServer* self, gdouble value);
gchar* media_local_rtsp_server_get_video_size (MediaLocalRTSPServer* self);
gdouble media_local_rtsp_server_get_video_quality_factor (MediaLocalRTSPServer* self);
void media_local_rtsp_server_set_video_quality_factor (MediaLocalRTSPServer* self, gdouble value);
gdouble media_local_rtsp_server_get_video_fps_factor (MediaLocalRTSPServer* self);
void media_local_rtsp_server_set_video_fps_factor (MediaLocalRTSPServer* self, gdouble value);
static void media_local_rtsp_server_finalize (GObject* obj);
static void _vala_media_local_rtsp_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_media_local_rtsp_server_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


void media_init (gchar*** args, int* args_length1) {
	gst_init (args_length1, args);
}


static gpointer _gst_object_ref0 (gpointer self) {
	return self ? gst_object_ref (self) : NULL;
}


MediaRTSPClient* media_rtsp_client_construct (GType object_type, GstElement* vsink) {
	MediaRTSPClient * self = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	g_return_val_if_fail (vsink != NULL, NULL);
	self = (MediaRTSPClient*) g_object_new (object_type, NULL);
	_tmp0_ = vsink;
	_tmp1_ = _gst_object_ref0 (_tmp0_);
	_gst_object_unref0 (self->priv->video_sink);
	self->priv->video_sink = _tmp1_;
	media_rtsp_client_build_playbin (self);
	return self;
}


MediaRTSPClient* media_rtsp_client_new (GstElement* vsink) {
	return media_rtsp_client_construct (MEDIA_TYPE_RTSP_CLIENT, vsink);
}


MediaRTSPClient* media_rtsp_client_construct_playing (GType object_type, GstElement* vsink, const gchar* uri) {
	MediaRTSPClient * self = NULL;
	GstElement* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (vsink != NULL, NULL);
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = vsink;
	self = (MediaRTSPClient*) media_rtsp_client_construct (object_type, _tmp0_);
	_tmp1_ = uri;
	media_rtsp_client_set_uri (self, _tmp1_);
	media_rtsp_client_start (self);
	return self;
}


MediaRTSPClient* media_rtsp_client_new_playing (GstElement* vsink, const gchar* uri) {
	return media_rtsp_client_construct_playing (MEDIA_TYPE_RTSP_CLIENT, vsink, uri);
}


static inline void _dynamic_set_stream_properties0 (GstElement* obj, GstStructure* value) {
	g_object_set (obj, "stream-properties", value, NULL);
}


static inline void _dynamic_set_video_sink1 (GstElement* obj, GstElement* value) {
	g_object_set (obj, "video-sink", value, NULL);
}


static inline void _dynamic_set_audio_sink2 (GstElement* obj, GstObject* value) {
	g_object_set (obj, "audio-sink", value, NULL);
}


static inline GstObject* _dynamic_get_source3 (GstObject* obj) {
	GstObject* result;
	g_object_get (obj, "source", &result, NULL);
	return result;
}


static inline void _dynamic_set_latency4 (GstObject* obj, gint value) {
	g_object_set (obj, "latency", value, NULL);
}


static inline void _dynamic_set_udp_buffer_size5 (GstObject* obj, gint value) {
	g_object_set (obj, "udp-buffer-size", value, NULL);
}


static void __lambda2_ (MediaRTSPClient* self, GstElement* e) {
	GstElement* _tmp0_;
	GstObject* _tmp1_;
	GstObject* element;
	GstObject* _tmp2_;
	GstObject* _tmp3_;
	GstObject* src;
	g_return_if_fail (e != NULL);
	_tmp0_ = e;
	_tmp1_ = _gst_object_ref0 ((GstObject*) _tmp0_);
	element = _tmp1_;
	_tmp2_ = _dynamic_get_source3 (element);
	_tmp3_ = _tmp2_;
	src = _tmp3_;
	_dynamic_set_latency4 (src, 250);
	_dynamic_set_udp_buffer_size5 (src, (2 * 1024) * 1024);
	_gst_object_unref0 (src);
	_gst_object_unref0 (element);
}


static void ___lambda2__dynamic_source_setup0_ (GstElement* _sender, gpointer self) {
	__lambda2_ (self, _sender);
}


void _dynamic_source_setup1_connect (gpointer obj, const char * signal_name, GCallback handler, gpointer data) {
	g_signal_connect_object (obj, signal_name, handler, data, 0);
}


static void media_rtsp_client_build_playbin (MediaRTSPClient* self) {
	GstElement* _tmp0_ = NULL;
	GstElement* _tmp1_;
	GstStructure* _tmp2_ = NULL;
	GstStructure* _tmp3_;
	GstElement* _tmp4_;
	GstElement* _tmp5_ = NULL;
	GstElement* _tmp6_;
	GstElement* _tmp7_;
	GstElement* _tmp8_;
	GstElement* _tmp9_;
	GstObject* _tmp10_ = NULL;
	GstElement* _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gst_element_factory_make ("pulsesink", "ps");
	gst_object_ref_sink (_tmp0_);
	_gst_object_unref0 (self->priv->audio_sink);
	self->priv->audio_sink = _tmp0_;
	_tmp1_ = self->priv->audio_sink;
	_tmp2_ = gst_structure_from_string ("props," "media.role=phone," "filter.want=echo-cancel", NULL);
	_tmp3_ = _tmp2_;
	_dynamic_set_stream_properties0 (_tmp1_, _tmp3_);
	_gst_structure_free0 (_tmp3_);
	_tmp4_ = self->priv->audio_sink;
	g_object_bind_property_with_closures ((GObject*) self, "mute", (GObject*) _tmp4_, "mute", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)));
	_tmp5_ = gst_element_factory_make ("playbin2", "pb");
	gst_object_ref_sink (_tmp5_);
	_gst_object_unref0 (self->priv->playbin);
	self->priv->playbin = _tmp5_;
	_tmp6_ = self->priv->playbin;
	_tmp7_ = self->priv->video_sink;
	_dynamic_set_video_sink1 (_tmp6_, _tmp7_);
	_tmp8_ = self->priv->playbin;
	_tmp9_ = self->priv->audio_sink;
	_tmp10_ = gst_object_ref ((GstObject*) _tmp9_);
	_dynamic_set_audio_sink2 (_tmp8_, _tmp10_);
	_tmp11_ = self->priv->playbin;
	_dynamic_source_setup1_connect (_tmp11_, "source_setup", (GCallback) ___lambda2__dynamic_source_setup0_, self);
}


static inline void _dynamic_set_uri6 (GstElement* obj, const gchar* value) {
	g_object_set (obj, "uri", value, NULL);
}


void media_rtsp_client_start (MediaRTSPClient* self) {
	GstElement* _tmp0_;
	const gchar* _tmp1_;
	GstElement* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->playbin;
	_tmp1_ = self->priv->_uri;
	_dynamic_set_uri6 (_tmp0_, _tmp1_);
	_tmp2_ = self->priv->playbin;
	gst_element_set_state (_tmp2_, GST_STATE_PLAYING);
}


void media_rtsp_client_stop (MediaRTSPClient* self) {
	GstElement* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->playbin;
	gst_element_set_state (_tmp0_, GST_STATE_NULL);
}


const gchar* media_rtsp_client_get_uri (MediaRTSPClient* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_uri;
	result = _tmp0_;
	return result;
}


void media_rtsp_client_set_uri (MediaRTSPClient* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_uri);
	self->priv->_uri = _tmp1_;
	g_object_notify ((GObject *) self, "uri");
}


gboolean media_rtsp_client_get_mute (MediaRTSPClient* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_mute;
	result = _tmp0_;
	return result;
}


void media_rtsp_client_set_mute (MediaRTSPClient* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_mute = _tmp0_;
	g_object_notify ((GObject *) self, "mute");
}


static void media_rtsp_client_class_init (MediaRTSPClientClass * klass) {
	media_rtsp_client_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MediaRTSPClientPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_media_rtsp_client_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_media_rtsp_client_set_property;
	G_OBJECT_CLASS (klass)->finalize = media_rtsp_client_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_RTSP_CLIENT_URI, g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_RTSP_CLIENT_MUTE, g_param_spec_boolean ("mute", "mute", "mute", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void media_rtsp_client_instance_init (MediaRTSPClient * self) {
	gchar* _tmp0_;
	self->priv = MEDIA_RTSP_CLIENT_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("");
	self->priv->_uri = _tmp0_;
	self->priv->_mute = FALSE;
}


static void media_rtsp_client_finalize (GObject* obj) {
	MediaRTSPClient * self;
	self = MEDIA_RTSP_CLIENT (obj);
	media_rtsp_client_stop (self);
	_gst_object_unref0 (self->priv->playbin);
	_gst_object_unref0 (self->priv->video_sink);
	_gst_object_unref0 (self->priv->audio_sink);
	_g_free0 (self->priv->_uri);
	G_OBJECT_CLASS (media_rtsp_client_parent_class)->finalize (obj);
}


GType media_rtsp_client_get_type (void) {
	static volatile gsize media_rtsp_client_type_id__volatile = 0;
	if (g_once_init_enter (&media_rtsp_client_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MediaRTSPClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_rtsp_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaRTSPClient), 0, (GInstanceInitFunc) media_rtsp_client_instance_init, NULL };
		GType media_rtsp_client_type_id;
		media_rtsp_client_type_id = g_type_register_static (G_TYPE_OBJECT, "MediaRTSPClient", &g_define_type_info, 0);
		g_once_init_leave (&media_rtsp_client_type_id__volatile, media_rtsp_client_type_id);
	}
	return media_rtsp_client_type_id__volatile;
}


static void _vala_media_rtsp_client_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MediaRTSPClient * self;
	self = MEDIA_RTSP_CLIENT (object);
	switch (property_id) {
		case MEDIA_RTSP_CLIENT_URI:
		g_value_set_string (value, media_rtsp_client_get_uri (self));
		break;
		case MEDIA_RTSP_CLIENT_MUTE:
		g_value_set_boolean (value, media_rtsp_client_get_mute (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_media_rtsp_client_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MediaRTSPClient * self;
	self = MEDIA_RTSP_CLIENT (object);
	switch (property_id) {
		case MEDIA_RTSP_CLIENT_URI:
		media_rtsp_client_set_uri (self, g_value_get_string (value));
		break;
		case MEDIA_RTSP_CLIENT_MUTE:
		media_rtsp_client_set_mute (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


MediaLocalRTSPServer* media_local_rtsp_server_construct (GType object_type) {
	MediaLocalRTSPServer * self = NULL;
	GstRTSPServer* _tmp0_;
	GstRTSPServer* _tmp1_;
	GstRTSPMediaMapping* _tmp2_ = NULL;
	GstRTSPServer* _tmp3_;
	self = (MediaLocalRTSPServer*) g_object_new (object_type, NULL);
	_tmp0_ = gst_rtsp_server_new ();
	_g_object_unref0 (self->priv->server);
	self->priv->server = _tmp0_;
	_tmp1_ = self->priv->server;
	_tmp2_ = gst_rtsp_server_get_media_mapping (_tmp1_);
	_g_object_unref0 (self->priv->mapping);
	self->priv->mapping = _tmp2_;
	_tmp3_ = self->priv->server;
	g_object_bind_property_with_closures ((GObject*) self, "port", (GObject*) _tmp3_, "service", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)));
	return self;
}


MediaLocalRTSPServer* media_local_rtsp_server_new (void) {
	return media_local_rtsp_server_construct (MEDIA_TYPE_LOCAL_RTSP_SERVER);
}


static gpointer _g_main_loop_ref0 (gpointer self) {
	return self ? g_main_loop_ref (self) : NULL;
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


void media_local_rtsp_server_attach (MediaLocalRTSPServer* self, GMainLoop* l) {
	GMainLoop* _tmp0_;
	GMainLoop* _tmp1_;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_;
	GstRTSPServer* _tmp4_;
	const gchar* _tmp5_;
	GstRTSPServer* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_;
	const gchar* _tmp11_ = NULL;
	const gchar* _tmp12_;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_;
	GstRTSPServer* _tmp19_;
	GMainLoop* _tmp20_;
	GMainContext* _tmp21_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (l != NULL);
	_tmp0_ = l;
	_tmp1_ = _g_main_loop_ref0 (_tmp0_);
	_g_main_loop_unref0 (self->priv->loop);
	self->priv->loop = _tmp1_;
	_tmp3_ = self->priv->_use_ipv6;
	if (_tmp3_) {
		_tmp2_ = "::0";
	} else {
		_tmp2_ = "0.0.0.0";
	}
	_tmp4_ = self->priv->server;
	_tmp5_ = _tmp2_;
	gst_rtsp_server_set_address (_tmp4_, _tmp5_);
	_tmp6_ = self->priv->server;
	_tmp7_ = gst_rtsp_server_get_address (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = string_to_string (_tmp8_);
	_tmp10_ = self->priv->_port;
	_tmp11_ = string_to_string (_tmp10_);
	_tmp12_ = self->priv->_mountpoint;
	_tmp13_ = string_to_string (_tmp12_);
	_tmp14_ = g_strconcat ("rtsp://", _tmp9_, ":", _tmp11_, "/", _tmp13_, NULL);
	_tmp15_ = _tmp14_;
	media_local_rtsp_server_set_address (self, _tmp15_);
	_g_free0 (_tmp15_);
	_tmp16_ = self->priv->_mountpoint;
	_tmp17_ = media_local_rtsp_server_build_default_launchline (self);
	_tmp18_ = _tmp17_;
	media_local_rtsp_server_add_mapping (self, _tmp16_, _tmp18_);
	_g_free0 (_tmp18_);
	_tmp19_ = self->priv->server;
	_tmp20_ = self->priv->loop;
	_tmp21_ = g_main_loop_get_context (_tmp20_);
	gst_rtsp_server_attach (_tmp19_, _tmp21_);
}


void media_local_rtsp_server_add_mapping (MediaLocalRTSPServer* self, const gchar* mountpoint, const gchar* launchline) {
	GstRTSPMediaFactory* _tmp0_;
	GstRTSPMediaFactory* factory;
	GstRTSPAuth* _tmp1_;
	GstRTSPAuth* auth;
	const gchar* _tmp2_;
	GstRTSPMediaFactory* _tmp10_;
	GstRTSPMediaFactory* _tmp11_;
	const gchar* _tmp12_;
	GstRTSPMediaFactory* _tmp13_;
	GstRTSPMediaMapping* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GstRTSPMediaFactory* _tmp18_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (mountpoint != NULL);
	g_return_if_fail (launchline != NULL);
	_tmp0_ = gst_rtsp_media_factory_new ();
	factory = _tmp0_;
	_tmp1_ = gst_rtsp_auth_new ();
	auth = _tmp1_;
	_tmp2_ = self->priv->_password;
	if (_tmp2_ != NULL) {
		GstRTSPAuth* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		GstRTSPMediaFactory* _tmp8_;
		GstRTSPAuth* _tmp9_;
		_tmp3_ = auth;
		_tmp4_ = self->priv->_user;
		_tmp5_ = self->priv->_password;
		_tmp6_ = gst_rtsp_auth_make_basic (_tmp4_, _tmp5_);
		_tmp7_ = _tmp6_;
		gst_rtsp_auth_set_basic (_tmp3_, _tmp7_);
		_g_free0 (_tmp7_);
		_tmp8_ = factory;
		_tmp9_ = auth;
		gst_rtsp_media_factory_set_auth (_tmp8_, _tmp9_);
	}
	_tmp10_ = factory;
	g_object_set (_tmp10_, "shared", TRUE, NULL);
	_tmp11_ = factory;
	_tmp12_ = launchline;
	gst_rtsp_media_factory_set_launch (_tmp11_, _tmp12_);
	_tmp13_ = factory;
	g_object_ref ((GObject*) _tmp13_);
	_tmp14_ = self->priv->mapping;
	_tmp15_ = mountpoint;
	_tmp16_ = g_strconcat ("/", _tmp15_, NULL);
	_tmp17_ = _tmp16_;
	_tmp18_ = factory;
	gst_rtsp_media_mapping_add_factory (_tmp14_, _tmp17_, _tmp18_);
	_g_free0 (_tmp17_);
	_g_object_unref0 (auth);
	_g_object_unref0 (factory);
}


static gchar* media_local_rtsp_server_build_default_launchline (MediaLocalRTSPServer* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* qustr;
	gint qustr_length1;
	gint _qustr_size_;
	const gchar* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* launchline;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gchar, 128);
	qustr = _tmp0_;
	qustr_length1 = 128;
	_qustr_size_ = qustr_length1;
	_tmp1_ = self->priv->_video_device;
	_tmp2_ = media_local_rtsp_server_get_video_width (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = media_local_rtsp_server_get_video_height (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = media_local_rtsp_server_get_video_fps (self);
	_tmp7_ = _tmp6_;
	_tmp8_ = media_local_rtsp_server_get_video_quality (self);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_ascii_dtostr (qustr, qustr_length1, _tmp9_);
	_tmp11_ = g_strdup_printf ("( \n" \
"  (\n" \
"    v4l2src device=%s \n" \
"    ! videorate \n" \
"    ! aspectratiocrop aspect-ratio=16/9 \n" \
"    ! videoscale \n" \
"    ! video/x-raw-yuv,width=%.0f,height=%.0f,framerate=%.0f/1 \n" \
"    ! schroenc force-profile=vc2_simple quality=%s queue-depth=5\n" \
"  )\n" \
"  ! queue \n" \
"  ! rtpgstpay pt=96 name=pay0\n" \
"\n" \
"  (\n" \
"    pulsesrc do-timestamp=true stream-properties='props,media.role=pho" \
"ne,filter.want=echo-cancel' \n" \
"    ! vobisenc \n" \
"  )\n" \
"  ! queue \n" \
"  ! rtpgstpay pt=97 name=pay1 \n" \
")", _tmp1_, _tmp3_, _tmp5_, _tmp7_, _tmp10_);
	launchline = _tmp11_;
	result = launchline;
	qustr = (g_free (qustr), NULL);
	return result;
}


void media_local_rtsp_server_quit (MediaLocalRTSPServer* self) {
	GMainLoop* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->loop;
	if (_tmp0_ != NULL) {
		GMainLoop* _tmp1_;
		_tmp1_ = self->priv->loop;
		g_main_loop_quit (_tmp1_);
	}
}


gboolean media_local_rtsp_server_get_use_ipv6 (MediaLocalRTSPServer* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_use_ipv6;
	result = _tmp0_;
	return result;
}


void media_local_rtsp_server_set_use_ipv6 (MediaLocalRTSPServer* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_use_ipv6 = _tmp0_;
	g_object_notify ((GObject *) self, "use-ipv6");
}


const gchar* media_local_rtsp_server_get_port (MediaLocalRTSPServer* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_port;
	result = _tmp0_;
	return result;
}


void media_local_rtsp_server_set_port (MediaLocalRTSPServer* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_port);
	self->priv->_port = _tmp1_;
	g_object_notify ((GObject *) self, "port");
}


const gchar* media_local_rtsp_server_get_mountpoint (MediaLocalRTSPServer* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_mountpoint;
	result = _tmp0_;
	return result;
}


void media_local_rtsp_server_set_mountpoint (MediaLocalRTSPServer* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_mountpoint);
	self->priv->_mountpoint = _tmp1_;
	g_object_notify ((GObject *) self, "mountpoint");
}


const gchar* media_local_rtsp_server_get_address (MediaLocalRTSPServer* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_address;
	result = _tmp0_;
	return result;
}


static void media_local_rtsp_server_set_address (MediaLocalRTSPServer* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_address);
	self->priv->_address = _tmp1_;
	g_object_notify ((GObject *) self, "address");
}


const gchar* media_local_rtsp_server_get_user (MediaLocalRTSPServer* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user;
	result = _tmp0_;
	return result;
}


static void media_local_rtsp_server_set_user (MediaLocalRTSPServer* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_user);
	self->priv->_user = _tmp1_;
	g_object_notify ((GObject *) self, "user");
}


const gchar* media_local_rtsp_server_get_password (MediaLocalRTSPServer* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_password;
	result = _tmp0_;
	return result;
}


void media_local_rtsp_server_set_password (MediaLocalRTSPServer* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_password);
	self->priv->_password = _tmp1_;
	g_object_notify ((GObject *) self, "password");
}


const gchar* media_local_rtsp_server_get_video_device (MediaLocalRTSPServer* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_video_device;
	result = _tmp0_;
	return result;
}


void media_local_rtsp_server_set_video_device (MediaLocalRTSPServer* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_video_device);
	self->priv->_video_device = _tmp1_;
	g_object_notify ((GObject *) self, "video-device");
}


gdouble media_local_rtsp_server_get_video_scale_factor (MediaLocalRTSPServer* self) {
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_video_scale_factor;
	result = _tmp0_;
	return result;
}


void media_local_rtsp_server_set_video_scale_factor (MediaLocalRTSPServer* self, gdouble value) {
	gdouble _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_video_scale_factor = _tmp0_;
	g_object_notify ((GObject *) self, "video-scale-factor");
}


gdouble media_local_rtsp_server_get_video_width (MediaLocalRTSPServer* self) {
	gdouble result;
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->base_width;
	_tmp1_ = self->priv->_video_scale_factor;
	result = _tmp0_ * _tmp1_;
	return result;
}


gdouble media_local_rtsp_server_get_video_height (MediaLocalRTSPServer* self) {
	gdouble result;
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->base_height;
	_tmp1_ = self->priv->_video_scale_factor;
	result = _tmp0_ * _tmp1_;
	return result;
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


gchar* media_local_rtsp_server_get_video_size (MediaLocalRTSPServer* self) {
	gchar* result;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = media_local_rtsp_server_get_video_width (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = double_to_string (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = media_local_rtsp_server_get_video_height (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = double_to_string (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat (_tmp3_, "x", _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp3_);
	result = _tmp9_;
	return result;
}


gdouble media_local_rtsp_server_get_video_quality_factor (MediaLocalRTSPServer* self) {
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_video_quality_factor;
	result = _tmp0_;
	return result;
}


void media_local_rtsp_server_set_video_quality_factor (MediaLocalRTSPServer* self, gdouble value) {
	gdouble _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_video_quality_factor = _tmp0_;
	g_object_notify ((GObject *) self, "video-quality-factor");
}


gdouble media_local_rtsp_server_get_video_quality (MediaLocalRTSPServer* self) {
	gdouble result;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble range;
	gdouble _tmp2_;
	gdouble _tmp3_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->base_quality_max;
	_tmp1_ = self->priv->base_quality_min;
	range = _tmp0_ - _tmp1_;
	_tmp2_ = self->priv->base_quality_min;
	_tmp3_ = self->priv->_video_quality_factor;
	result = _tmp2_ + (range * _tmp3_);
	return result;
}


gdouble media_local_rtsp_server_get_video_fps_factor (MediaLocalRTSPServer* self) {
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_video_fps_factor;
	result = _tmp0_;
	return result;
}


void media_local_rtsp_server_set_video_fps_factor (MediaLocalRTSPServer* self, gdouble value) {
	gdouble _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_video_fps_factor = _tmp0_;
	g_object_notify ((GObject *) self, "video-fps-factor");
}


gdouble media_local_rtsp_server_get_video_fps (MediaLocalRTSPServer* self) {
	gdouble result;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble range;
	gdouble _tmp2_;
	gdouble _tmp3_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->base_fps_max;
	_tmp1_ = self->priv->base_fps_min;
	range = _tmp0_ - _tmp1_;
	_tmp2_ = self->priv->base_fps_min;
	_tmp3_ = self->priv->_video_fps_factor;
	result = _tmp2_ + (range * _tmp3_);
	return result;
}


static void media_local_rtsp_server_class_init (MediaLocalRTSPServerClass * klass) {
	media_local_rtsp_server_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MediaLocalRTSPServerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_media_local_rtsp_server_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_media_local_rtsp_server_set_property;
	G_OBJECT_CLASS (klass)->finalize = media_local_rtsp_server_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_USE_IPV6, g_param_spec_boolean ("use-ipv6", "use-ipv6", "use-ipv6", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_PORT, g_param_spec_string ("port", "port", "port", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_MOUNTPOINT, g_param_spec_string ("mountpoint", "mountpoint", "mountpoint", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_ADDRESS, g_param_spec_string ("address", "address", "address", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_USER, g_param_spec_string ("user", "user", "user", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_PASSWORD, g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_VIDEO_DEVICE, g_param_spec_string ("video-device", "video-device", "video-device", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_VIDEO_SCALE_FACTOR, g_param_spec_double ("video-scale-factor", "video-scale-factor", "video-scale-factor", -G_MAXDOUBLE, G_MAXDOUBLE, 0.25, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_VIDEO_WIDTH, g_param_spec_double ("video-width", "video-width", "video-width", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_VIDEO_HEIGHT, g_param_spec_double ("video-height", "video-height", "video-height", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_VIDEO_SIZE, g_param_spec_string ("video-size", "video-size", "video-size", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_VIDEO_QUALITY_FACTOR, g_param_spec_double ("video-quality-factor", "video-quality-factor", "video-quality-factor", -G_MAXDOUBLE, G_MAXDOUBLE, 0.75, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_VIDEO_QUALITY, g_param_spec_double ("video-quality", "video-quality", "video-quality", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_VIDEO_FPS_FACTOR, g_param_spec_double ("video-fps-factor", "video-fps-factor", "video-fps-factor", -G_MAXDOUBLE, G_MAXDOUBLE, 0.5, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MEDIA_LOCAL_RTSP_SERVER_VIDEO_FPS, g_param_spec_double ("video-fps", "video-fps", "video-fps", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void media_local_rtsp_server_instance_init (MediaLocalRTSPServer * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	self->priv = MEDIA_LOCAL_RTSP_SERVER_GET_PRIVATE (self);
	self->priv->base_width = (gdouble) 1280;
	self->priv->base_height = (gdouble) 720;
	self->priv->base_quality_min = (gdouble) 4;
	self->priv->base_quality_max = (gdouble) 10;
	self->priv->base_fps_min = (gdouble) 4;
	self->priv->base_fps_max = (gdouble) 20;
	self->priv->_use_ipv6 = FALSE;
	_tmp0_ = g_strdup ("8554");
	self->priv->_port = _tmp0_;
	_tmp1_ = g_strdup ("presence");
	self->priv->_mountpoint = _tmp1_;
	_tmp2_ = g_strdup ("presence");
	self->priv->_user = _tmp2_;
	self->priv->_password = NULL;
	_tmp3_ = g_strdup ("/dev/video0");
	self->priv->_video_device = _tmp3_;
	self->priv->_video_scale_factor = 0.25;
	self->priv->_video_quality_factor = 0.75;
	self->priv->_video_fps_factor = 0.5;
}


static void media_local_rtsp_server_finalize (GObject* obj) {
	MediaLocalRTSPServer * self;
	self = MEDIA_LOCAL_RTSP_SERVER (obj);
	_g_main_loop_unref0 (self->priv->loop);
	_g_object_unref0 (self->priv->server);
	_g_object_unref0 (self->priv->mapping);
	_g_free0 (self->priv->_port);
	_g_free0 (self->priv->_mountpoint);
	_g_free0 (self->priv->_address);
	_g_free0 (self->priv->_user);
	_g_free0 (self->priv->_password);
	_g_free0 (self->priv->_video_device);
	G_OBJECT_CLASS (media_local_rtsp_server_parent_class)->finalize (obj);
}


GType media_local_rtsp_server_get_type (void) {
	static volatile gsize media_local_rtsp_server_type_id__volatile = 0;
	if (g_once_init_enter (&media_local_rtsp_server_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MediaLocalRTSPServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_local_rtsp_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaLocalRTSPServer), 0, (GInstanceInitFunc) media_local_rtsp_server_instance_init, NULL };
		GType media_local_rtsp_server_type_id;
		media_local_rtsp_server_type_id = g_type_register_static (G_TYPE_OBJECT, "MediaLocalRTSPServer", &g_define_type_info, 0);
		g_once_init_leave (&media_local_rtsp_server_type_id__volatile, media_local_rtsp_server_type_id);
	}
	return media_local_rtsp_server_type_id__volatile;
}


static void _vala_media_local_rtsp_server_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MediaLocalRTSPServer * self;
	self = MEDIA_LOCAL_RTSP_SERVER (object);
	switch (property_id) {
		case MEDIA_LOCAL_RTSP_SERVER_USE_IPV6:
		g_value_set_boolean (value, media_local_rtsp_server_get_use_ipv6 (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_PORT:
		g_value_set_string (value, media_local_rtsp_server_get_port (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_MOUNTPOINT:
		g_value_set_string (value, media_local_rtsp_server_get_mountpoint (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_ADDRESS:
		g_value_set_string (value, media_local_rtsp_server_get_address (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_USER:
		g_value_set_string (value, media_local_rtsp_server_get_user (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_PASSWORD:
		g_value_set_string (value, media_local_rtsp_server_get_password (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_DEVICE:
		g_value_set_string (value, media_local_rtsp_server_get_video_device (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_SCALE_FACTOR:
		g_value_set_double (value, media_local_rtsp_server_get_video_scale_factor (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_WIDTH:
		g_value_set_double (value, media_local_rtsp_server_get_video_width (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_HEIGHT:
		g_value_set_double (value, media_local_rtsp_server_get_video_height (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_SIZE:
		g_value_take_string (value, media_local_rtsp_server_get_video_size (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_QUALITY_FACTOR:
		g_value_set_double (value, media_local_rtsp_server_get_video_quality_factor (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_QUALITY:
		g_value_set_double (value, media_local_rtsp_server_get_video_quality (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_FPS_FACTOR:
		g_value_set_double (value, media_local_rtsp_server_get_video_fps_factor (self));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_FPS:
		g_value_set_double (value, media_local_rtsp_server_get_video_fps (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_media_local_rtsp_server_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MediaLocalRTSPServer * self;
	self = MEDIA_LOCAL_RTSP_SERVER (object);
	switch (property_id) {
		case MEDIA_LOCAL_RTSP_SERVER_USE_IPV6:
		media_local_rtsp_server_set_use_ipv6 (self, g_value_get_boolean (value));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_PORT:
		media_local_rtsp_server_set_port (self, g_value_get_string (value));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_MOUNTPOINT:
		media_local_rtsp_server_set_mountpoint (self, g_value_get_string (value));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_ADDRESS:
		media_local_rtsp_server_set_address (self, g_value_get_string (value));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_USER:
		media_local_rtsp_server_set_user (self, g_value_get_string (value));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_PASSWORD:
		media_local_rtsp_server_set_password (self, g_value_get_string (value));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_DEVICE:
		media_local_rtsp_server_set_video_device (self, g_value_get_string (value));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_SCALE_FACTOR:
		media_local_rtsp_server_set_video_scale_factor (self, g_value_get_double (value));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_QUALITY_FACTOR:
		media_local_rtsp_server_set_video_quality_factor (self, g_value_get_double (value));
		break;
		case MEDIA_LOCAL_RTSP_SERVER_VIDEO_FPS_FACTOR:
		media_local_rtsp_server_set_video_fps_factor (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



